unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,DateUtils, ExtCtrls;

type
  TForm1 = class(TForm)
    panel2: TStaticText;
    panel3: TStaticText;
    panel1: TStaticText;
    Btn_LstMon1: TStaticText;
    Btn_NexMon1: TStaticText;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure dPanelClick(Sender: TObject);
    procedure Btn_LstMon1Click(Sender: TObject);
    procedure Btn_NexMon1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  TarGetDate : Tdatetime;
  date_sl, Week_sl, Day_sl, True_sl : Tstringlist;
  dpanel : array of TPanel ;
  dlabel : array of TLabel;
implementation

{$R *.dfm}

function GetDate(Date1:Tdatetime):string;
begin
   result :=  FormatDateTime('yyyy/MM/dd',  Date1);
end;

function GetYear(Date1:Tdatetime):string;
begin
   result :=  FormatDateTime('yyyy',  Date1);
end;

function GetMonth(Date1:Tdatetime):string;
var
   amonth : string;
begin
   aMonth := inttostr(strtoint(FormatDateTime('MM',  Date1)));
   result :=  amonth;
end;

function GetDay(Date1:Tdatetime):string;
var
  aDay:String;
begin
  try
     aDay := inttostr(strtoint(FormatDateTime('dd',  Date1)));
  except
  end;
  result := aDay;
end;

function GetAllMonthDays(xDate:TDateTime):boolean;
var
  aYear, aMonth, aDay ,aDate,aWeek : string;
  MonthFirstWeek,MonthLastWeek : string;
  MonthFirstDay ,MonthLastDay: string;
  DayCount : integer;
  i : integer;
begin
  date_sl.Clear;
  Week_sl.Clear;
  Day_sl.Clear;
  True_sl.Clear;
  aYear  := GetYear(xDate);
  aMonth := GetMonth(xDate);
  DayCount := DaysInMonth(xDate);
  // oU  P
  for i := 1 to DayCount do begin
      aDay := inttostr(i);
      aDate := aYear + '/' + aMonth + '/' + aDay;
      aWeek := inttostr(DayOfWeek(strToDate(aDate)));
      date_sl.Add(aDate);
      Week_sl.Add(aWeek);
      Day_sl.Add(GetDay(StrToDate(aDate)));
      True_sl.Add('1');                                // true This Month Day
  end;
  // Last Month
  MonthFirstDay  := date_sl.Strings[0];
  MonthLastDay   := date_sl.Strings[date_sl.count-1];
  MonthFirstWeek := Week_sl.Strings[0];
  MonthLastWeek  := Week_sl.Strings[Week_sl.count-1];
   // Check the first is SunDay
   if trim(MonthFirstWeek) <> '1' then begin
     // show last month day
     aDate := MonthFirstDay;
     for i := strtoint(MonthFirstWeek)-2 downto 0 do begin
         aDate := datetostr(strtodate(aDate)-1);
         aWeek := inttostr(DayOfWeek(strToDate(aDate)));
         date_sl.Insert(0,aDate);
         Week_sl.Insert(0,aWeek);
         Day_sl.Insert(0,GetDay(StrToDate(aDate)));
         True_sl.Insert(0,'0');                                // False This Month Day
     end;
   end;
   // Show Next Month
   daycount := date_sl.Count;  // ReCount Day
   aDate := MonthLastDay;
   for i := 0 to 42 - daycount-1 do begin // Add Next Month Day
       aDate := datetostr(strtodate(aDate)+1);
       aWeek := inttostr(DayOfWeek(strToDate(aDate)));
       date_sl.Add(aDate);
       Week_sl.add(aWeek);
       Day_sl.add(GetDay(StrToDate(aDate)));
       True_sl.Add('0');                                // False This Month Day
   end;
   result := true;
end;

function MakeWeekTitle(TC:TWincontrol):boolean;
var i : integer;
    WWidth, WHeight,newleft : integer;
    wStaticT : Array of TStaticText;
    days: array[0..6] of string;
begin
    days[0] := 'P';
    days[1] := 'P@';
    days[2] := 'PG';
    days[3] := 'PT';
    days[4] := 'P|';
    days[5] := 'P';
    days[6] := 'P';
    setlength(wStaticT,7);
    WWidth := TC.width div 7;
    WHeight:= Tc.Height;
    newleft := 0;
    for i := 0 to 6 do begin
        wStaticT[i] := TStaticText.Create(TC);
        wStaticT[i].Parent := TC;
        wStaticT[i].Width :=  WWidth;
        wStaticT[i].Left :=newleft;
        wStaticT[i].Height := WHeight;
        wStaticT[i].Alignment := tacenter;
        wStaticT[i].BevelKind := bkSoft;
        wStaticT[i].BevelOuter := bvRaised;
        wStaticT[i].BorderStyle := sbsSunken;
        wStaticT[i].AutoSize := false;
        wStaticT[i].Caption := days[i];
        wStaticT[i].Visible := true;
        newleft := newleft + wwidth;
    end;
    result := true;
end;

function MakeMonthCalade(TC:TWincontrol):boolean;
var
  i,newleft,newtop,cnt,dwidth,dheight :integer;
begin
  setlength( dpanel, 42);
  setlength( dlabel, 42);
  dwidth :=  ((TC.Width) div 7);
  dheight:=  ((TC.height) div 6);
  newleft := 0;
  newtop := 0;
  cnt := 0;
  for i := 0 to 42-1 do begin
      dpanel[i] := TPanel.Create(TC);
      dpanel[i].Parent := TC;
      dpanel[i].BorderStyle := bsNone	;
      dpanel[i].Color := clWhite;
      dpanel[i].Width := dwidth;
      dpanel[i].Height := dheight;
      dpanel[i].Left := newleft;
      dpanel[i].Top  := newtop;
      dpanel[i].Visible := true;
      dpanel[i].Tag := i;
      dpanel[i].OnClick := form1.dPanelClick;

      dlabel[i] := Tlabel.Create(TC);
      dlabel[i].Parent := dpanel[i];
      dlabel[i].Align := AlTop;
      dlabel[i].Alignment := taRightJustify ;
      dlabel[i].height := (dheight div 5);
      dlabel[i].Color := $00D6CFBE;
      dlabel[i].Visible := true;

      newleft := newleft + dwidth;
      inc(cnt);
      if cnt mod 7 =0 then begin
         newleft := 0;
         newtop := newtop + dHeight;
      end;
  end;
  result := true;
end;

function SetMonthCalade(xDate:TDateTime):boolean;
var
  i, i1 : integer;
begin
  GetAllMonthDays(xDate);

  for i := 0 to 42-1 do begin
      i1:=i +1;
      dlabel[i].Font.Name := 'Times New Roman';
      dlabel[i].Font.Size := 14;
      dlabel[i].Caption := day_sl[i];
      // show today
      if strtodate(datetostr(now))=strtodate(date_sl[i]) then begin
         dpanel[i].Color := clInfoBk;
      end
      else begin
         dpanel[i].Color := clWhite;
      end;
      // not this month days color
      if True_sl[i]='0' then begin          // Not this month
         dlabel[i].Font.Color := clGray;
      end
      else  if i mod 7 =0 then begin        // Sunday
           dlabel[i].font.Color := clred;
      end
      else if i1 mod 7 = 0 then begin
           dlabel[i].font.Color := clGreen; // satday
      end
      else begin
          dlabel[i].Font.Color := clbLACK;  // normal day
      end;
  end;
  result := true;
end;

procedure TForm1.dPanelClick(Sender:TObject);
begin
    showmessage(date_sl[(Sender as Tpanel).Tag]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  date_sl := Tstringlist.Create;  // Date
  Week_sl := Tstringlist.Create;  // Week
  Day_sl  := Tstringlist.Create;  // Day
  True_sl := Tstringlist.Create;  // Is My Month
  MakeWeekTitle(panel3);
  MakeMonthCalade(panel2);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
   TarGetDate := strtodate(datetostr(now));
   SetMonthCalade(TarGetDate);
   panel1.Caption :=  GetYear(TarGetDate)+'~' +GetMonth(TarGetDate)+'';
end;

procedure TForm1.Btn_LstMon1Click(Sender: TObject);
var
   aYear, aMonth, aDay   : string;
begin
   aYear  := GetYear(TarGetDate);
   aMonth := GetMonth(TarGetDate);
   aDay   := GetDay(TarGetDate);
   if strtoint(aMonth) > 1 then begin
      aMonth := inttostr(strtoint(aMonth) -1);
   end
   else begin
      aYear  := inttostr(strtoint(aYear)-1);
      aMonth := '12';
   end;
   TarGetDate  := strtodate(aYear + '/' + aMonth + '/' + aDay);
   panel1.Caption := aYear + '~' + aMonth + '';
   SetMonthCalade(TarGetDate);
end;

procedure TForm1.Btn_NexMon1Click(Sender: TObject);
var
   aYear, aMonth, aDay  : string;
begin
   aYear  := GetYear(TarGetDate);
   aMonth := GetMonth(TarGetDate);
   aDay   := GetDay(TarGetDate);
   if strtoint(aMonth) < 12 then begin
      aMonth := inttostr(strtoint(aMonth) +1);
   end
   else begin
      aYear  := inttostr(strtoint(aYear)+1);
      aMonth := '1';
   end;
   TarGetDate  := strtodate(aYear + '/' + aMonth + '/' + aDay);
   panel1.Caption := aYear + '~' + aMonth + '';
   SetMonthCalade(TarGetDate);
end;

end.
